# -*- coding: utf-8 -*-

import mingus.containers.Note as Note
import mingus.core.chords as chords
import mingus.core.scales as scales
import mingus.core.diatonic as diatonic

class Calc():
    def __init__(self, parent = None):
        self.numList = []
        self.diffList = []
        self.charList = []
        self.notesList = []
        self.chordsList = []
        self.scalesList = []
        self.key_offset = 0
        self.velocity = 127
        self.diatonicList = []
        self.in_diatonic = 1
    
    def intervals(self, key_selected,  intervals_selected, inversion):
        self.numList = []
        self.diffList = []
        self.charList = []
        self.notesList = []
        self.chordsList = []
        self.key_offset = int(Note(key_selected))

        for i in range(0, len(intervals_selected)):
            self.numList.append(int(intervals_selected[i].text(0)))
            self.numList.sort()
        
        for i in range(0, len(self.numList)):
            self.diffList.append(abs(self.numList[i] - self.numList[i-1]) )
            note_number = self.key_offset + self.numList[i]
            self.charList.append(diatonic.int_to_note((note_number)%12 , key_selected))
            cur_note = Note(self.charList[i], note_number/12)
            cur_note.velocity = self.velocity
            self.notesList.append(cur_note)
            
        if inversion == 1:
            self.notesList = chords.first_inversion(self.notesList)
            self.charList = chords.first_inversion(self.charList)
            self.diffList = self.diffList[1:] + [self.diffList[0]]
            
        elif inversion == 2:    
            self.notesList = chords.second_inversion(self.notesList)
            self.charList = chords.second_inversion(self.charList)
            self.diffList = self.diffList[2:] + [self.diffList[0]] + [self.diffList[1]]  
            
        elif inversion == 3:
            self.notesList = chords.third_inversion(self.notesList)
            self.charList = chords.third_inversion(self.charList)
            self.diffList =self.diffList[3:] + [self.diffList[0]] + [self.diffList[1] ]+ [self.diffList[1]]
            
        return self.notesList,  self.charList,  self.diffList
        
    def chords(self):
        self.chordsList = chords.determine(self.charList , True,  True,  True)
        return self.chordsList

    def scales(self):
        self.scalesList = scales.determine(self.charList)
        return self.scalesList
